SystemOrganization addCategory: #CopyHierarchy!

!ClassDescription methodsFor: '*CopyHierarchy' stamp: 'hjo 4/20/2012 10:18'!
definitionWithSuperclass
	"Answer a String that defines the receiver."

	| aStream |
	aStream := (String new: 800) writeStream.
	aStream nextPutAll: self kindOfSubclass;
			store: self name.
	(self hasTraitComposition and: [self traitComposition notEmpty]) ifTrue: [
		aStream cr; tab; nextPutAll: 'uses: ';
			nextPutAll: self traitCompositionString].
	aStream cr; tab; nextPutAll: 'instanceVariableNames: ';
			store: self instanceVariablesString.
	aStream cr; tab; nextPutAll: 'classVariableNames: ';
			store: self classVariablesString.
	aStream cr; tab; nextPutAll: 'poolDictionaries: ';
			store: self sharedPoolsString.
	aStream cr; tab; nextPutAll: 'category: ';
			store: self category asString.

	superclass ifNil: [ 
		aStream nextPutAll: '.'; cr.
		aStream nextPutAll: self name.
		aStream space; nextPutAll: 'superclass: nil'. ].

	^ aStream contents! !

Object subclass: #CopyHierarchy
	instanceVariableNames: 'classNamePrefix classCategoryForDupedClass subclassesOfClassToDup classToDup'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CopyHierarchy'!

!CopyHierarchy methodsFor: 'as yet unclassified' stamp: 'hjo 4/20/2012 11:10'!
changeSuperclassAfterDupClass: aClass

	| t |
	t := aClass duplicateClassWithNewName: (self nameOfDupOfClass: aClass).
	t category: classCategoryForDupedClass.
	self halt.
	self moveClassNamed: aClass name toSuper: (self nameOfDupOfClass: aClass superclass).! !

!CopyHierarchy methodsFor: 'as yet unclassified' stamp: 'hjo 4/20/2012 10:53'!
dupClass: aClass

	| t |
	t := aClass duplicateClassWithNewName: (self nameOfDupOfClass: aClass).
	t category: classCategoryForDupedClass.
	

	 ! !

!CopyHierarchy methodsFor: 'as yet unclassified' stamp: 'hjo 4/20/2012 10:26'!
moveClassNamed: classSymbol toSuper: superClassSymbol

	Compiler evaluate: (superClassSymbol ,  (Smalltalk at: classSymbol) definitionWithSuperclass).! !

!CopyHierarchy methodsFor: 'as yet unclassified' stamp: 'hjo 4/20/2012 10:55'!
moveLeavesToDupedSuper

	subclassesOfClassToDup do: [:each| 
		self moveClassNamed: (self nameOfDupOfClass: each) toSuper: (self nameOfDupOfClass: classToDup).
		].! !

!CopyHierarchy methodsFor: 'as yet unclassified' stamp: 'hjo 4/20/2012 10:52'!
nameOfDupOfClass: aClass

	^(classNamePrefix, aClass name) asSymbol! !

!CopyHierarchy methodsFor: 'as yet unclassified' stamp: 'hjo 4/20/2012 11:09'!
run

	subclassesOfClassToDup := classToDup subclasses.
	self dupClass: classToDup.
	subclassesOfClassToDup do: [ :each | self changeSuperclassAfterDupClass: each ].
	"self moveLeavesToDupedSuper"! !

!CopyHierarchy methodsFor: 'as yet unclassified' stamp: 'hjo 4/20/2012 11:01'!
runGraidentFillStyle
	classNamePrefix := 'TK'.
	classCategoryForDupedClass := 'Talon'.
	classToDup := GradientFillStyle.
	self run.! !

!CopyHierarchy methodsFor: 'as yet unclassified' stamp: 'hjo 4/20/2012 11:02'!
runLineSegment
	classNamePrefix := 'Daliot'.
	classCategoryForDupedClass := 'DuppyDup'.
	classToDup := LineSegment.
	self run.! !

!CopyHierarchy methodsFor: 'as yet unclassified' stamp: 'hjo 4/20/2012 10:01'!
tearDown

	self class environment organization removeSystemCategory: classCategoryForDupedClass.! !
